<template>
    <div class="flex justify-center pt-[30px] space-x-2">
        <slot></slot>
        <div v-for="(button, i) in actionWorkflow" :key="i">
            <el-button :disabled="!canSubmit" type="primary" class="min-w-[100px] rounded-full"
                :class="buttonColors[button?.btnAction]" @click="onSubmit(button)">
                {{ button?.btnAction }}
            </el-button>
        </div>

        <slot name="print"></slot>
    </div>
    <div class="relative py-3 space-y-5" v-if="approvalWorkflow.length > 0">
        <div>
            <h2 class="font-mm font-bold text-primary">
                <fa-icon class="mr-1" icon="fa-solid fa-arrow-trend-up" />
                Approval Workflows
            </h2>
            <div class="overflow-x-auto relative border rounded-2xl mt-4">
                <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
                    <thead class=" text-primary uppercase bg-gray-50 dark:bg-gray-700">
                        <tr>
                            <th v-for="(flow, i) in approvalWorkflow" :key="i" scope="col" class="py-3 px-6">
                                {{ flow.role_name }}
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr class="bg-white dark:bg-gray-800">
                            <th scope="row"
                                class="py-4 px-6 font-medium text-gray-900 whitespace-nowrap dark:text-white"
                                v-for="(flow, i) in approvalWorkflow" :key="i">
                                <div v-for="(p, j) in flow?.people" :key="j">
                                    <fa-icon class="mr-1 text-secondary" v-if="p?.is_done"
                                        icon="fa-solid fa-circle-check" />
                                    <fa-icon class="mr-1 text-secondary opacity-75" v-else icon="fa-solid fa-circle" />
                                    {{ p.full_name }}
                                </div>
                            </th>

                        </tr>
                    </tbody>
                </table>
            </div>
        </div>

        <div>
            <h2 class="font-mm mt-6 font-bold text-primary">
                <fa-icon class="mr-1" icon="fa-solid fa-clock" />
                Workflow Histories{{ count }}
            </h2>
            <div class="overflow-x-auto relative border rounded-2xl mt-4">
                <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
                    <thead class=" text-primary uppercase bg-gray-50 dark:bg-gray-700">
                        <tr>
                            <th scope="col" class="py-3 px-6">
                                Status
                            </th>
                            <th scope="col" class="py-3 px-6">
                                Updated On
                            </th>
                            <th scope="col" class="py-3 px-6">
                                Updated By
                            </th>
                            <th scope="col" class="py-3 px-6">
                                Comment
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="(wh, i) in workflowHistoryModel" :key="i" class="bg-white dark:bg-gray-800">
                            <th scope="row"
                                class="py-4 px-6 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                                {{ wh.post_status }}
                            </th>
                            <th scope="row"
                                class="py-4 px-6 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                                {{ $dayjs(wh.created_at).format("MMM D, YYYY h:mm A") }}
                            </th>
                            <th scope="row"
                                class="py-4 px-6 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                                {{ wh.full_name }}
                            </th>
                            <th scope="row"
                                class="py-4 px-6 font-medium bg-d text-gray-900 whitespace-nowrap dark:text-white">
                                {{ wh.comment }}
                            </th>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>

<script>
import { useStore } from 'vuex';
import { ElMessageBox } from 'element-plus';

export default {
    name: "VWorkflow",
    props: {
        data: {
            type: Object,
            default: () => ({})
        },
        canSubmit: {
            type: Boolean,
            default: false
        },
        executeApi: {
            type: String,
            default: ''
        }
    },
    computed: {
        buttonColors() {
            return {
                "Submit": "bg-primary border-primary hover:bg-primary-80 focus:bg-primary-80 disabled:hover:bg-primary",
                "Back to modify": "bg-red-900 border-red-900 hover:bg-red-800 disabled:hover:bg-red-900 focus:bg-red-900",
                "Reviewed": "bg-success border-success hover:bg-green-700 disabled:hover:bg-success focus:bg-success",
                "Rejected": "bg-red-600 border-red-600 hover:bg-red-500 disabled:hover:bg-red-600 focus:bg-red-600",
                "Approved": "bg-success border-success hover:bg-green-700 disabled:hover:bg-success focus:bg-success"
            }
        },
        actionWorkflow() {
            return this.data?.approvalAction || []
        },
        approvalWorkflow() {
            return this.data?.approvalWorkflow || []
        },
        workflowHistoryModel() {
            return this.data?.workflowHistoryModel || []
        }
    },
    setup(props) {
        const store = useStore();
        const onSubmit = async (button) => {
            try {
                const { value } = await ElMessageBox.prompt('Comment(s)', 'Confirmation', {
                    confirmButtonText: 'Confirm',
                    cancelButtonText: 'Cancel',
                    inputErrorMessage: 'Please enter comment!',
                    inputValidator: (value) => {
                        if (value) {
                            return true;
                        }

                        return "Please enter comment!";
                    }
                });

                const id = props?.data?.data?.id;

                await store.dispatch("Workflow/onSubmitWorkflow", {
                    WfDetailUuid: `${button.wfDetailUuid}`,
                    refId: id + "",
                    comment: value
                });

                if (props?.executeApi) {
                    await store.dispatch(props?.executeApi, id);
                }
            }
            catch (error) {
                console.log(error);
            }

        }

        return {
            onSubmit
        }
    }
}
</script>
